{
    By Ben Golightly 2010, tophatstuff.co.uk
    Feel free to modify and use with or without credit
}
Program
    Uses
        cobra2d,
        keyset

Const
    WORLD_XSIZE = 1024
    WORLD_YSIZE = 768

Var
    tile: Array[WORLD_XSIZE, WORLD_YSIZE] of Real
    x, y, c, m: Integer = 0
    roughness: Real = 2.0
    canvas: Element

Procedure DivideGrid(x1: Integer, y1: Integer, x2: Integer, y2: Integer)
Var
    w, h : Integer
    midx, midy: Integer
    c, d: Real
Begin
    
    w = x2-x1
    h = y2-y1
    midx = (x1+x2)/2
    midy = (y1+y2)/2
    
    d = ((ToReal(w+h)/2) / ToReal(WORLD_XSIZE + WORLD_YSIZE))
    d = d * Rnd(-1,1) * roughness
    
    If (w > 1) or (h > 1) then
    
        tile[midx, y1] = (tile[x1, y1] + tile[x2, y1]) / 2
        tile[midx, y2] = (tile[x1, y2] + tile[x2, y2]) / 2
        tile[x1, midy] = (tile[x1, y1] + tile[x1, y2]) / 2
        tile[x2, midy] = (tile[x2, y1] + tile[x2, y2]) / 2
        tile[midx, midy] = d + ((tile[x1, y1] + tile[x1, y2] + tile[x2, y1] + tile[x2, y2]) / 4)
        If tile[midx, midy] > 1 then tile[midx, midy] = 1
        If tile[midx, midy] < 0 then tile[midx, midy] = 0
    
        DivideGrid(x1,y1,midx,midy)
        DivideGrid(midx,y1,x2,midy)
        DivideGrid(x1,midy,midx,y2)
        DivideGrid(midx,midy,x2,y2)

    Endif

End

Begin
    
    Randomize
    SetAppName("Random Terrain Generation Prototype")
    OpenScreen(1024, 768, 32, FALSE, COB_SHOWBORDER)
    
    canvas = CreateSprite(WORLD_XSIZE, WORLD_YSIZE)
    PositionSprite(canvas, (1024-WORLD_XSIZE)/2, (768-WORLD_YSIZE)/2)
   
    While (KeyHits(VK_ESCAPE) < 1)
        
        If ((Millisecs - m) > 1000) then
        
            tile[0, 0] = 0.5
            tile[WORLD_XSIZE-1, 0] = 0.5
            tile[0, WORLD_YSIZE-1] = 0.5
            tile[WORLD_XSIZE-1, WORLD_YSIZE-1] = 0.5

            DivideGrid(0,0,WORLD_XSIZE-1,WORLD_YSIZE-1)
    
            For x = 0 to WORLD_XSIZE-1
                For y = 0 to WORLD_YSIZE-1
                    c = tile[x,y]*255.0
                    Pixel(x,y,ToRGBA(c,c,c),canvas)
                Next
            Next
            
            m = millisecs
        Endif
        
        If KeyDown(VK_UP) then roughness = roughness + 0.05
        If KeyDown(VK_DOWN) then roughness = roughness - 0.05
        SetAppName("Random Terrain Generation Prototype. Turbulance is "+roughness+", press up/down to adjust")
    
        Flip
        Pause(1)
    Wend 


End
